---
title: Get multiple key-value pairs
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[KV](https://developers.cloudflare.com/api/go/resources/kv)

[Namespaces](https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Get multiple key-value pairs

client.KV.Namespaces.BulkGet(ctx, namespaceID, params) (\*[NamespaceBulkGetResponse](<https://developers.cloudflare.com/api/go/resources/kv#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/storage/kv/namespaces/{namespace\_id}/bulk/get

Retrieves the text-based values of up to 100 keys from the specified Workers KV namespace. The result maps each requested key to its value. Set `type` to `json` to parse JSON values instead of returning strings, and set `withMetadata` to `true` to include metadata with each value. Binary values are not supported by this operation.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Workers KV Storage Write``Workers KV Storage Read`

##### ParametersExpand Collapse

namespaceID string

ID of the Workers KV namespace.

maxLength32

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20namespace_id%20%3E%20(schema)>)

<details>

<summary>

params NamespaceBulkGetParams

</summary>

AccountID param.Field\[string]

Path param: ID of the Cloudflare account that owns the Workers KV namespaces.

maxLength32

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Keys param.Field\[\[]string]

Body param: Array of keys to retrieve (maximum of 100).

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20keys">Link to this property</a>

<details>

<summary>

Type param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/bulk_get#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type%20%3E%20(schema)">NamespaceBulkGetParamsType</a>]Optional

Body param: Return values as strings with <code>text</code>, or parse stored JSON values with <code>json</code>.

</summary>

const NamespaceBulkGetParamsTypeText <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/bulk_get#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type%20%3E%20(schema)">NamespaceBulkGetParamsType</a> = "text"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

const NamespaceBulkGetParamsTypeJson <a href="https://developers.cloudflare.com/api/go/resources/kv/subresources/namespaces/methods/bulk_get#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type%20%3E%20(schema)">NamespaceBulkGetParamsType</a> = "json"

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20type">Link to this property</a>

WithMetadata param.Field\[bool]Optional

Body param: Whether to include metadata in the response.

<a href="#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default%20%3E%20(param)%20withMetadata">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(method)%20bulk_get%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type NamespaceBulkGetResponse interface{…}

</summary>

One of the following:

<details>

<summary>

type NamespaceBulkGetResponseWorkersKVBulkGetResult struct{…}

</summary>

<details>

<summary>

Values map\[string, NamespaceBulkGetResponseWorkersKVBulkGetResultValuesUnion]Optional

Requested keys are paired with their values in an object.

</summary>

One of the following:

UnionString

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%200">Link to this property</a>

UnionFloat

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%201">Link to this property</a>

UnionBool

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%202">Link to this property</a>

type NamespaceBulkGetResponseWorkersKVBulkGetResultValuesMap map\[string, unknown]

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(variant)%203">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200%20%3E%20(property)%20values">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%200">Link to this property</a>

<details>

<summary>

type NamespaceBulkGetResponseWorkersKVBulkGetResultWithMetadata struct{…}

</summary>

<details>

<summary>

Values map\[string, NamespaceBulkGetResponseWorkersKVBulkGetResultWithMetadataValue]Optional

Requested keys are paired with their values and metadata in an object.

</summary>

Metadata unknown

The metadata associated with the key.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(property)%20metadata">Link to this property</a>

Value unknown

The value associated with the key.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(property)%20value">Link to this property</a>

Expiration float64Optional

Expires the key at a certain time, measured in number of seconds since the UNIX epoch.

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20values%20%3E%20(items)%20%3E%20(property)%20expiration">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20values">Link to this property</a>

</details>

<a href="#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20kv.namespaces%20%3E%20(model)%20NamespaceBulkGetResponse%20%3E%20(schema)>)

### Get multiple key-value pairs

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/kv"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.KV.Namespaces.BulkGet(
    context.TODO(),
    "0f2ac74b498b48028cb68387c421e279",
    kv.NamespaceBulkGetParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
      Keys: cloudflare.F([]string{"My-Key"}),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response)
}
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "values": {
      "key1": "value1",
      "key2": "value2"
    }
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "values": {
      "key1": "value1",
      "key2": "value2"
    }
  }
}
```